<?php

if (!defined('ABSPATH')) {
    exit;
}

class TransactionCloudCustomizedProduct
{
    public $link;
    public $customProductId;

    /**
     * @return string
     */
    public function getRedirectLink()
    {
        return $this->link;
    }

    /**
     * @return string
     */
    public function getCustomProductId()
    {
        return $this->customProductId;
    }

    /**
     * Creates object from given API's JSON string
     * 
     * @param string $json
     * 
     * @return self
     */
    public static function make($json)
    {
        $obj = json_decode($json, false, 512, JSON_THROW_ON_ERROR);
    
        if (!isset($obj->link) || !isset($obj->customProductId)) {
            throw new TransactionCloudMapException('Could not map json string to object');
        }

        $customizedProduct = new static();
    
        $customizedProduct->link = $obj->link;
        $customizedProduct->customProductId = $obj->customProductId;
    
        return $customizedProduct;
    }
}
